//+------------------------------------------------------------------+
//|                                                       _Line3.mq4 |
//|                                                  Victor Nicolaev |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Victor Nicolaev"
#property link      "vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Yellow

//---- input parameters
extern string gSymbol="USDJPY";
extern int mode =1; //1 - y=a*x+b
                    //2 - y=a*x^2+b*x+c
                    //3 - y=a*x^3+b*x^2+c*x+d
extern int iPeriod= 21;
extern int iShift =  0;

extern int iPrice=PRICE_CLOSE; 
//0-PRICE_CLOSE;1-PRICE_OPEN;2-PRICE_HIGH;3-PRICE_LOW;
//4-PRICE_MEDIAN;5-PRICE_TYPICAL;6-PRICE_WEIGHTED

//---- buffers
double ExtMapBuffer0[];
double a[];
double Input1[];
double Input2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
//---- drawing settings
//   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,0);
   SetIndexShift(0,iShift);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer0);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Line ("+mode+","+iPeriod+")");
   SetIndexLabel(0,"Line"+mode);
   ArrayResize(a,mode+1);
   ArrayResize(Input1,iPeriod);
   ArrayResize(Input2,iPeriod);
   for (int i=0;i<iPeriod;i++) Input2[i]=i+1;
   
//---- initialization done
   return(0); }//int init() 
//+------------------------------------------------------------------+
int start() {
   int limit;
   int counted_bars=IndicatorCounted();
   int i, j;
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if (limit>1440) limit = 1440;
//---- macd counted in the 1-st buffer
   for (i = limit;i>=0;i--) {
      for (j=0;j<iPeriod;j++)  {
         Input1[j]=fPrice(Symbol(),iPrice,j+i);
         Input2[j]=fPrice(gSymbol, iPrice,j+i);
      }
      fLine(mode+1, Input1, Input2,iPeriod);
      ExtMapBuffer0[i]=0;
      for (j=0;j<=mode;j++)
         ExtMapBuffer0[i]+=a[j];
    }   
   return(0); }// int start()
   
   

void fLine(int N, double Input1[], double Input2[], int n){

   double   sx[], syx[];
   int N1=N+1;
   int N2=N1+N;

   ArrayResize(sx,  N2);
   ArrayResize(syx, N1);
      
   ArrayInitialize(sx,0);
   ArrayInitialize(syx,0);
  
   sx[0]=n;
   double y, tmp;

   int i, j;
   double x;
   for (i = 0; i<n;i++) {
      x=Input2[i];
      y=Input1[i];
      tmp=1; 
      for (j=1;j<N2;j++) {tmp*=x; sx[j]+=tmp;}
      tmp=y; syx[0]+=tmp; 
      for (j=1;j<N1;j++) {tmp*=x; syx[j]+=tmp;}
      
      }

   Gauss(sx, syx);
   for (i=0;i<N1;i++) a[i]=syx[i];

   return; 
}   //double fLine(int iPeriod,int iPrice,int i)

   
void Gauss(double Input[], double & Output[]){
   int i, j, k;
   int N=ArraySize(Output);
   double A[];
   ArrayResize(A, N*N);
   for (i=0;i<N;i++) {
      for (j=0;j<N;j++) 
         A[Index(N,i,j)]=Input[j+i];
   }
   for(i=0;i < N-1;i++) {
      Output[i]/=A[Index(N,i,i)];
      for(k=i+1;k < N;k++) {
         Output[k]-=Output[i]*A[Index(N,k,i)];
         for(j=i+1;j < N;j++) {
            A[Index(N,i,j)]/=A[Index(N,i,i)];
            A[Index(N,k,j)]-=A[Index(N,k,i)]*A[Index(N,i,j)];
         }
         A[Index(N,k,i)]=0.0;
      }
      A[Index(N,i,i)]=1.0;
   }
   Output[N-1]/=A[Index(N,N-1,N-1)];

   for(i=N-2;i >=0;i--)
      for(j=N-1;j>i;j--)
         Output[i]-=A[Index(N,i,j)]*Output[j];  

}

int Index(int N, int i, int j){return(N*i+j);}
   
//+------------------------------------------------------------------+
   
 double fPrice(string lSymbol, int iPrice, int i) {
   double RetVal;
   switch (iPrice) {
      case 1:  RetVal=iOpen(lSymbol,0,i); break;
      case 2:  RetVal=iHigh(lSymbol,0,i); break;
      case 3:  RetVal=iLow(lSymbol,0,i) ; break;
      case 4:  RetVal=(iHigh(lSymbol,0,i)+iLow(lSymbol,0,i))/2; break;
      case 5:  RetVal=(iHigh(lSymbol,0,i)+iLow(lSymbol,0,i)+iClose(lSymbol,0,i))/3; break;
      case 6:  RetVal=(iHigh(lSymbol,0,i)+iLow(lSymbol,0,i)+2*iClose(lSymbol,0,i))/4; break;
      default: RetVal=iClose(lSymbol,0,i); 
      }// switch (price) 
   return(RetVal);}
//+------------------------------------------------------------------+   


